/**
 * @file
 * @brief C++ internals initialization
 * @date 08.06.2012
 * @author Vladimir Sokolov
 */

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <embox/cmd.h>
#include <types.h>

EMBOX_CMD(exec);

typedef void (*func_ptr)(void);

	/* inits and constructors area markers. Generated by linker script */
extern const char _ctors_start;
extern const char _ctors_end;

static int exec(int argc, char **argv) {
	func_ptr *func;
	uint n_entries;

	for (func = (func_ptr *) &_ctors_start, n_entries = 0;
			*func && (func != (func_ptr *) &_ctors_end);
			func++, n_entries++) {
				/* printf("%u entry, address == 0x%lx \r\n", n_entries, (unsigned long)(*func) ); */
				(*func)();
	}

	printf("%u init and constructor functions were called \r\n", n_entries);

	return ENOERR;
}
